var Cus00600_CustoPlanejadoPeriodoController = function (ScreenService, General, restEngine, GeneralServices) {
	/*global Configuration, moment, Util, getLocalVar*/
	this.defaultValues = function(widget) {
		widget.newRow();
		GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
			if(callback.dataset.defaulttipocusto[0] && widget.currentRow.REPORT_NAME != 'CUS00604') {
				widget.getField('NMTIPOCUSTO1').setValue(callback.dataset.defaulttipocusto[0].CDTIPOCUSTO + " | " + callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
				widget.currentRow.NMTIPOCUSTO_BKP = callback.dataset.defaulttipocusto[0].NMTIPOCUSTO;
				widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
				widget.currentRow.CDTIPOCUSTO1 = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			} 
		});
		
		this.getLocalVarOnEnter(widget);
		this.agrupNivel(widget);
	};

	this.validaData = function (currentRow) {
		var dataInicial = currentRow.DTINICIAL ? moment(currentRow.DTINICIAL, 'DD/MM/YYYY')._d : null;
		var dataFinal 	= currentRow.DTFINAL ? moment(currentRow.DTFINAL, 'DD/MM/YYYY')._d : null;
		var mensagem 	= ScreenService.i18n("A data final deve ser menor ou igual a data final.");

		if (dataInicial && dataFinal && dataFinal < dataInicial) {
			ScreenService.showMessage(mensagem);
			return false;
		}

		return true;
	};

	this.updateChildrenFields = function(field, dependentFields){
		this.onChangeField(field, dependentFields);
		this.atualizaListaDeServico(field.widget);
	};

	this.atualizaListaDeServico = function(widget) {
		let currentRow = widget.currentRow;
		let grupoServicos = '';
		let fieldServico = widget.getField('NMSERVICO');
		let fieldFilial = widget.getField('NMFILIAL1');
		let CDFILIAL = fieldFilial.value() ? widget.currentRow.CDFILIAL1 : '';
		if(currentRow.ALLGRUPSERV == 'N' && currentRow.NMGRUPSERV.length) {
			grupoServicos = currentRow.NMGRUPSERV.join('_');
		} else if (currentRow.ALLGRUPSERV == 'S'){
			grupoServicos = 'T';
		} 
		fieldServico.dataSourceFilter = [
			
			{
				"name": "CDOPERADOR",
				"operator": "=",
				"value": getLocalVar('CDOPERADOR')
			},
			{
				"name": "CDFILIAL",
				"operator": "=",
				"value": CDFILIAL
			},
			{
				"name": "CDGRUPSERV",
				"operator": "=",
				"value": grupoServicos
			},
			{
				"name": "NRORG",
				"operator": "=",
				"value": getLocalVar('NRORG')
			}
		];
		fieldServico.reload();
	};	

	this.validaIDProdutos = function(widget) {
		var resultado = '';

		if (widget.getField('IDMATEPRIM').value() == "S") {
			resultado += "C";
		} else {
			resultado += "X";
		}

		if (widget.getField('IDCONSFIXO').value() == "S") {
			resultado += "F";
		} else {
			resultado += "X";
		}

		if (widget.getField('IDCONSPERC').value() == "S") {
			resultado += "P";
		} else {
			resultado += "X";
		}
		widget.getField('IDPRODUTOS').setValue(resultado);
	};

	this.ordenaProduto = function(widget) {
		var ordenacao_tipo = widget.getField('ORDENA').value();

		if(ordenacao_tipo == "0") {
		 	var tamanho_mascara = concatenaArrayMascara(getLocalVar('CDPICTPROD').split('.'));
		 	widget.currentRow.NRTAMCODIGO = tamanho_mascara;
		} else if(ordenacao_tipo == "1") {
			widget.currentRow.NRTAMCODIGO = 0;
		}
	};

	function concatenaArrayMascara (array) {
		var arrayString = '';
		for(var pos in array) {
			arrayString += array[pos];
		}
		return arrayString.length;
	}

	this.verificaCheckboxTodos = function(currentRow) {
		if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'N') {

			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'N') {

			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

		} else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'S') {

			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = 'REQUEST';

		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'S') {

			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = 'T';
		}
	};

	this.validaRelatorio = function(widget, args, currentRow) {
		var reportName = widget.currentRow.REPORT_NAME;
		var type = [
			{
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xlsx",
				value: "XLSX"
			}
		];

		if(widget.isValid() && this.validaData(currentRow)) {
			if(widget.currentRow.IDMATEPRIM == 'N' && widget.currentRow.IDCONSFIXO == 'N' && widget.currentRow.IDNAOESTOC == 'N' && widget.currentRow.IDCONSPERC == 'N'){
				ScreenService.showMessage(ScreenService.i18n("Tipo de produto deve ser informado."));
			}else {
				General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, args, reportName], type);
			}
		}
	};

	this.abreRelatorio = function(widget, currentRow, args, reportName) {

		this.validaIDProdutos(widget);
		this.verificaCheckboxTodos(currentRow);

		currentRow.DTPERIFINA = currentRow.DTFINAL;
		currentRow.DTPERIINIC = currentRow.DTINICIAL;
		currentRow.DTMESINIC  = moment(currentRow.DTINICIAL, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		currentRow.DTMESFINA  = moment(currentRow.DTFINAL, 	'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
		
		if(Util.isEmptyOrBlank(widget.currentRow.NMFILIAL_BKP)){
			widget.currentRow.NMFILIAL_BKP = null;
		}
		let mascaraProduto = getLocalVar('CDPICTPROD');
		args.row.P_CDPRODUTOFIN = ''.padEnd(mascaraProduto.split('.').join('').length, 'z');
		args.row.NRTAMACNIVEL = mascaraProduto.split('.').slice(0, args.row.NMTAMACNIVEL).join('').length;
		args.row.CDPICTPROD = "!" + getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");
		
		General.openReport('cus_relatorio#/cus00600_custo_planejado_periodo', reportName, args.row);

	}.bind(this);
	
	this.exportDateValues = function(field){
		if(field.value()){
			field.widget.currentRow.DTINICIAL = field.value().start || '';
			field.widget.currentRow.DTFINAL = field.value().end || ''; 
		}
	};
	
	this.getLocalVarOnEnter = function(widget){
		
		var date = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').format('DD/MM/YYYY');
		
		widget.getField('DTINTERVAL').value(
			{
				'start': date,
				'end': date,
				'formattedEnd': date,
				'formattedStart': date
			}
		);
		
		widget.currentRow.DTINICIAL = date;
		widget.currentRow.DTFINAL   = date;
		widget.currentRow.CDFILIAL1  = getLocalVar('CDFILIAL');
		widget.currentRow.NMFILIAL1  = getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL');
	};

	this.onChangeField = function(field, dependentFields){
		let widget = field.widget;
		if(field.hasOwnProperty('_outData')){
			this.bindOutDataCurrentRow(field);
		}
		if(field.isCheckBox && typeof field.fieldToggle === 'string'){
			General.toggleReadOnlySelect(field, widget.getField(field.fieldToggle));
		} 
		if(Array.isArray(dependentFields)){
			dependentFields.forEach(function(nameField){
				widget.currentRow[nameField] = Array.isArray(widget.currentRow[nameField]) ? [] : "";
			});
		}
	};
	this.bindOutDataCurrentRow = function(field){
        let widget  = field.widget;
        let outData = field._outData;
        if(outData){
            Object.keys(outData).forEach(function(property){
                widget.currentRow[outData[property]] = outData[property] === field.name ? 
                    widget.currentRow[outData[property]] : widget.currentRow[property];
            });
        }    
    };
    
    this.visibleFieldsSelectReport = function(widget){
    	var relatorio = widget.currentRow.REPORT_NAME;
    	
    	if(relatorio == 'CUS00604'){
    		widget.getField('NMFILIAL2').isVisible    = true;
    		widget.getField('NMTIPOCUSTO2').isVisible = true;
    	
    	} else{
    		widget.getField('NMFILIAL2').isVisible    = false;
    		widget.getField('NMTIPOCUSTO2').isVisible = false;
    	}
    	
    	this.defaultValueFieldReport00604(widget);
    };
    
    this.defaultValueFieldReport00604 = function(widget){
    	GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL2')).then(function(callback) {
			if(callback.dataset.defaulttipocusto[0] && widget.currentRow.REPORT_NAME == 'CUS00604') {
				widget.getField('NMTIPOCUSTO2').setValue(callback.dataset.defaulttipocusto[0].CDTIPOCUSTO + " | " + callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
				widget.currentRow.CDTIPOCUSTO2 = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			} 
		});
    };
    
    this.fieldNullUnidade2 = function(widget){
    	var row =  widget.currentRow;
    	if(Util.isEmptyOrBlank(row.NMFILIAL2)){
    		row.CDFILIAL2    = null;
    		row.NMFILIAL2    = null; 
    		row.NMFILIAL_BKP = null;
    	} 
    	else{
    		
    		widget.currentRow.NMFILIAL_BKP = row.NMFILIAL;
    	}
    };

    this.fieldNullTipodeCusto = function(widget){
    	if(Util.isEmptyOrBlank(widget.currentRow.NMTIPOCUSTO2)){
    		this.defaultValueFieldReport00604(widget);
    	}
    }; 
    
	this.agrupNivel = function(widget){
		let level = General.getLevelByMask('CDPICTPROD', 1);
		widget.currentRow.NRTAMCODIGO = level[level.length-1].caracteres;
		widget.currentRow.NMTAMACNIVEL = '0';
		if(level.length >= 2){
			level.pop();
			level.pop();
		}
		level.map(function(item){
			item.NMTAMACNIVEL = item.nivel;
		});
		level.unshift(
			{
				NMTAMACNIVEL: "0"
			}
		);
		widget.getField('NMTAMACNIVEL').dataSource.data = level; 
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus00600_CustoPlanejadoPeriodoController', Cus00600_CustoPlanejadoPeriodoController);
});