var Cus01900_CustoDaUnidadeDeRefeicao = function (ScreenService, General, GeneralServices, templateManager, ZhUtil, CUSUtilities){
     /*global Configuration, getLocalVar, date, relatorio moment*/
    this.defaultValues = function(widget) {
        let firstReport = widget.getField('CD_REPORT_NAME').dataSource.getFirstRow();

        
        widget.currentRow.CD_REPORT_NAME = firstReport.value;
        
        widget.getField('NMFILIAL').value(getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL'));
        widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
        
        widget.getField('NMTIPOCUSTO').reload().then(callback => {
          let typeOfCost = callback.dataset.type_cost_lang;
          
          if(typeOfCost && typeOfCost.length){
            let currentCost = typeOfCost[0];
            widget.currentRow.NMTIPOCUSTO = currentCost.CDTIPOCUSTO + ' | ' + currentCost.NMTIPOCUSTO;
            widget.currentRow.CDTIPOCUSTO = currentCost.CDTIPOCUSTO;
 
		widget.currentRow.DTINICIAL = date;
		widget.currentRow.DTFINAL = date;
		widget.currentRow.CD_REPORT_NAME = relatorio.value;   
          }
        });
		
    };
  
    this.onChangeUnity = function(args){
		var field = args.owner.field;
		var widget = field.widget;
		
		widget.getField('NMSERVICO').setValue([]);
		if(!field.value()){
			widget.currentRow.CDFILIAL = '';
		}
	};
	
	this.validacaoData = function (widget) {
		var dataInicial = moment(widget.currentRow.DTINICIAL, 'DD/MM/YYYY');
		var dataFinal 	= moment(widget.currentRow.DTFINAL, 'DD/MM/YYYY');
		var mensagem 	= ScreenService.i18n("A data final deve ser maior ou igual a data inicial.");

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
	};


    this.validacaoCampos = function(widget, row, currentRow) {
		var reportName = widget.currentRow.CD_REPORT_NAME;
		var grupprod = widget.getField('GRUPPROD').value();
		if(Object.keys(widget.currentRow).includes('CDGRUPPROD')){
			if(!grupprod){
				widget.currentRow.CDGRUPPROD = 'X';
			}
		}else{
			widget.currentRow.CDGRUPPROD = 'X';
		}
		if(widget.isValid() && this.validacaoData(widget)) {
			var reportFormats = [
			    {
			        name: "pdf",
			        value: "PDF"
			    },
			    {
			        name: "xlsx",
			        value: "XLSX"
			    }
			];
	        General.openReportPopup(widget, this.abreRelatorio, [reportName, row, currentRow], reportFormats);
		}
	};
	
	this.abreRelatorio = function(reportName, row, currentRow) {
		this.verificaCheckboxTodos(currentRow);
		General.openReport('cus_relatorio#/Cus01900_CustoDaUnidadeDeRefeicao', reportName, row);
	}.bind(this);
	
	this.onChangeUnity = function(args){
		var field = args.owner.field;
		var widget = field.widget;
		
		widget.getField('NMSERVICO').setValue([]);
		if(!field.value()){
			widget.currentRow.CDFILIAL = '';
		}
	};
	
	this.atualizaListaDeServico = function(widget) {
		var grupoServicos 	= '';
		var currentRow 		= widget.currentRow;

		if(currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		} 
		General.onClickDependentField(widget.getField('NMSERVICO'), {CDFILIAL: currentRow.CDFILIAL, CDGRUPSERV: grupoServicos});
	};	
	
	this.verificaCheckboxTodos = function(currentRow) {
		if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = 'REQUEST';
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = 'T';
		}
	};
	
	
};	

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus01900_CustoDaUnidadeDeRefeicao', Cus01900_CustoDaUnidadeDeRefeicao);
});